module multiplier4bit (top^a~0, top^a~1, top^a~2, top^a~3, top^b~0, top^b~1, top^b~2, top^b~3, random, top^out~0, top^out~1, top^out~2, top^out~3, top^out~4, top^out~5, top^out~6, top^out~7);

input top^a~0;
input top^a~1;
input top^a~2;
input top^a~3;
input top^b~0;
input top^b~1;
input top^b~2;
input top^b~3;
input random;
output top^out~0;
output top^out~1;
output top^out~2;
output top^out~3;
output top^out~4;
output top^out~5;
output top^out~6;
output top^out~7;

wire VDD = 1'b1;
wire VSS = 1'b0;

	NAND2X1 NAND2X1_1 ( .A(top^b~0), .B(top^a~0), .Z(temp_out_1) );
	INVX1 INVX1_1 ( .A(temp_out_1), .Z(temp_out_inv_1) );
	NAND2X1_DC NAND2X1_DC_1 ( .A(temp_out_1), .B(random), .Z(temp_1) );
	NAND2X1 NAND2X1_2 ( .A(temp_1), .B(temp_out_inv_1), .Z(n17) );
	INV_Skipped INV_Skipped_1 ( .A(n17), .Z(top^out~0) );
	NAND2X1 NAND2X1_3 ( .A(top^b~0), .B(top^a~1), .Z(temp_out_2) );
	INVX1 INVX1_2 ( .A(temp_out_2), .Z(temp_out_inv_2) );
	NAND2X1_DC NAND2X1_DC_2 ( .A(temp_out_2), .B(random), .Z(temp_2) );
	NAND2X1 NAND2X1_4 ( .A(temp_2), .B(temp_out_inv_2), .Z(n19) );
	NAND2X1 NAND2X1_5 ( .A(top^b~1), .B(top^a~0), .Z(temp_out_3) );
	INVX1 INVX1_3 ( .A(temp_out_3), .Z(temp_out_inv_3) );
	NAND2X1_DC NAND2X1_DC_3 ( .A(temp_out_3), .B(random), .Z(temp_3) );
	NAND2X1 NAND2X1_6 ( .A(temp_3), .B(temp_out_inv_3), .Z(n20) );
	XOR2X1 XOR2X1_1 ( .A(n20), .B(n19), .Z(temp_out_4) );
	INVX1 INVX1_4 ( .A(temp_out_4), .Z(temp_out_inv_4) );
	NAND2X1_DC NAND2X1_DC_4 ( .A(temp_out_4), .B(random), .Z(temp_4) );
	NAND2X1 NAND2X1_7 ( .A(temp_4), .B(temp_out_inv_4), .Z(top^out~1) );
	NOR2X1 NOR2X1_1 ( .A(n20), .B(n19), .Z(temp_out_5) );
	INVX1 INVX1_5 ( .A(temp_out_5), .Z(temp_out_inv_5) );
	NAND2X1_DC NAND2X1_DC_5 ( .A(temp_out_5), .B(random), .Z(temp_5) );
	NAND2X1 NAND2X1_8 ( .A(temp_5), .B(temp_out_inv_5), .Z(n22) );
	NAND2X1 NAND2X1_9 ( .A(top^b~0), .B(top^a~2), .Z(temp_out_6) );
	INVX1 INVX1_6 ( .A(temp_out_6), .Z(temp_out_inv_6) );
	NAND2X1_DC NAND2X1_DC_6 ( .A(temp_out_6), .B(random), .Z(temp_6) );
	NAND2X1 NAND2X1_10 ( .A(temp_6), .B(temp_out_inv_6), .Z(n23) );
	NAND2X1 NAND2X1_11 ( .A(top^b~1), .B(top^a~1), .Z(temp_out_7) );
	INVX1 INVX1_7 ( .A(temp_out_7), .Z(temp_out_inv_7) );
	NAND2X1_DC NAND2X1_DC_7 ( .A(temp_out_7), .B(random), .Z(temp_7) );
	NAND2X1 NAND2X1_12 ( .A(temp_7), .B(temp_out_inv_7), .Z(n24) );
	INV_C INV_C_1 ( .A(n24), .Z(n25) );
	XOR2X1 XOR2X1_2 ( .A(n25), .B(n23), .Z(temp_out_8) );
	INVX1 INVX1_8 ( .A(temp_out_8), .Z(temp_out_inv_8) );
	NAND2X1_DC NAND2X1_DC_8 ( .A(temp_out_8), .B(random), .Z(temp_8) );
	NAND2X1 NAND2X1_13 ( .A(temp_8), .B(temp_out_inv_8), .Z(n26) );
	XOR2X1 XOR2X1_3 ( .A(n24), .B(n23), .Z(temp_out_9) );
	INVX1 INVX1_9 ( .A(temp_out_9), .Z(temp_out_inv_9) );
	NAND2X1_DC NAND2X1_DC_9 ( .A(temp_out_9), .B(random), .Z(temp_9) );
	NAND2X1 NAND2X1_14 ( .A(temp_9), .B(temp_out_inv_9), .Z(n27) );
	MUX2X1 MUX2X1_1 ( .S(n22), .A(n27), .B(n26), .Z(n28) );
	NAND2X1 NAND2X1_15 ( .A(top^b~2), .B(top^a~0), .Z(temp_out_10) );
	INVX1 INVX1_10 ( .A(temp_out_10), .Z(temp_out_inv_10) );
	NAND2X1_DC NAND2X1_DC_10 ( .A(temp_out_10), .B(random), .Z(temp_10) );
	NAND2X1 NAND2X1_16 ( .A(temp_10), .B(temp_out_inv_10), .Z(n29) );
	INV_B INV_B_1 ( .A(n29), .Z(n30) );
	XOR2X1 XOR2X1_4 ( .A(n30), .B(n28), .Z(temp_out_11) );
	INVX1 INVX1_11 ( .A(temp_out_11), .Z(temp_out_inv_11) );
	NAND2X1_DC NAND2X1_DC_11 ( .A(temp_out_11), .B(random), .Z(temp_11) );
	NAND2X1 NAND2X1_17 ( .A(temp_11), .B(temp_out_inv_11), .Z(top^out~2) );
	NAND2X1 NAND2X1_18 ( .A(n30), .B(n28), .Z(temp_out_12) );
	INVX1 INVX1_12 ( .A(temp_out_12), .Z(temp_out_inv_12) );
	NAND2X1_DC NAND2X1_DC_12 ( .A(temp_out_12), .B(random), .Z(temp_12) );
	NAND2X1 NAND2X1_19 ( .A(temp_12), .B(temp_out_inv_12), .Z(n32) );
	NOR2X1 NOR2X1_2 ( .A(n24), .B(n23), .Z(temp_out_13) );
	INVX1 INVX1_13 ( .A(temp_out_13), .Z(temp_out_inv_13) );
	NAND2X1_DC NAND2X1_DC_13 ( .A(temp_out_13), .B(random), .Z(temp_13) );
	NAND2X1 NAND2X1_20 ( .A(temp_13), .B(temp_out_inv_13), .Z(n33) );
	NAND2X1 NAND2X1_21 ( .A(n24), .B(n23), .Z(temp_out_14) );
	INVX1 INVX1_14 ( .A(temp_out_14), .Z(temp_out_inv_14) );
	NAND2X1_DC NAND2X1_DC_14 ( .A(temp_out_14), .B(random), .Z(temp_14) );
	NAND2X1 NAND2X1_22 ( .A(temp_14), .B(temp_out_inv_14), .Z(n34) );
	MUX2X1 MUX2X1_2 ( .S(n22), .A(n33), .B(n34), .Z(n35) );
	NAND2X1 NAND2X1_23 ( .A(top^b~0), .B(top^a~3), .Z(temp_out_15) );
	INVX1 INVX1_15 ( .A(temp_out_15), .Z(temp_out_inv_15) );
	NAND2X1_DC NAND2X1_DC_15 ( .A(temp_out_15), .B(random), .Z(temp_15) );
	NAND2X1 NAND2X1_24 ( .A(temp_15), .B(temp_out_inv_15), .Z(n36) );
	NAND2X1 NAND2X1_25 ( .A(top^b~1), .B(top^a~2), .Z(temp_out_16) );
	INVX1 INVX1_16 ( .A(temp_out_16), .Z(temp_out_inv_16) );
	NAND2X1_DC NAND2X1_DC_16 ( .A(temp_out_16), .B(random), .Z(temp_16) );
	NAND2X1 NAND2X1_26 ( .A(temp_16), .B(temp_out_inv_16), .Z(n37) );
	XOR2X1 XOR2X1_5 ( .A(n37), .B(n36), .Z(temp_out_17) );
	INVX1 INVX1_17 ( .A(temp_out_17), .Z(temp_out_inv_17) );
	NAND2X1_DC NAND2X1_DC_17 ( .A(temp_out_17), .B(random), .Z(temp_17) );
	NAND2X1 NAND2X1_27 ( .A(temp_17), .B(temp_out_inv_17), .Z(n38) );
	INV_Skipped INV_Skipped_2 ( .A(n38), .Z(n39) );
	XOR2X1 XOR2X1_6 ( .A(n37), .B(n36), .Z(temp_out_18) );
	INVX1 INVX1_18 ( .A(temp_out_18), .Z(temp_out_inv_18) );
	NAND2X1_DC NAND2X1_DC_18 ( .A(temp_out_18), .B(random), .Z(temp_18) );
	NAND2X1 NAND2X1_28 ( .A(temp_18), .B(temp_out_inv_18), .Z(n40) );
	MUX2X1 MUX2X1_3 ( .S(n35), .A(n40), .B(n39), .Z(n41) );
	NAND2X1 NAND2X1_29 ( .A(top^b~2), .B(top^a~1), .Z(temp_out_19) );
	INVX1 INVX1_19 ( .A(temp_out_19), .Z(temp_out_inv_19) );
	NAND2X1_DC NAND2X1_DC_19 ( .A(temp_out_19), .B(random), .Z(temp_19) );
	NAND2X1 NAND2X1_30 ( .A(temp_19), .B(temp_out_inv_19), .Z(n42) );
	INV_Skipped INV_Skipped_3 ( .A(n42), .Z(n43) );
	NAND2X1 NAND2X1_31 ( .A(n43), .B(n41), .Z(temp_out_20) );
	INVX1 INVX1_20 ( .A(temp_out_20), .Z(temp_out_inv_20) );
	NAND2X1_DC NAND2X1_DC_20 ( .A(temp_out_20), .B(random), .Z(temp_20) );
	NAND2X1 NAND2X1_32 ( .A(temp_20), .B(temp_out_inv_20), .Z(n44) );
	INV_D INV_D_1 ( .A(n40), .Z(n45) );
	MUX2X1 MUX2X1_4 ( .S(n35), .A(n45), .B(n38), .Z(n46) );
	NAND2X1 NAND2X1_33 ( .A(n42), .B(n46), .Z(temp_out_21) );
	INVX1 INVX1_21 ( .A(temp_out_21), .Z(temp_out_inv_21) );
	NAND2X1_DC NAND2X1_DC_21 ( .A(temp_out_21), .B(random), .Z(temp_21) );
	NAND2X1 NAND2X1_34 ( .A(temp_21), .B(temp_out_inv_21), .Z(n47) );
	NAND2X1 NAND2X1_35 ( .A(n47), .B(n44), .Z(n48) );
	XOR2X1 XOR2X1_7 ( .A(n43), .B(n41), .Z(n49) );
	MUX2X1 MUX2X1_5 ( .S(n32), .A(n48), .B(n49), .Z(n50) );
	NAND2X1 NAND2X1_36 ( .A(top^b~3), .B(top^a~0), .Z(n51) );
	INV_Skipped INV_Skipped_4 ( .A(n51), .Z(n52) );
	XOR2X1 XOR2X1_8 ( .A(n52), .B(n50), .Z(top^out~3) );
	NAND2X1 NAND2X1_37 ( .A(n52), .B(n50), .Z(n54) );
	NOR2X1 NOR2X1_3 ( .A(n42), .B(n46), .Z(n55) );
	NAND2X1 NAND2X1_38 ( .A(n42), .B(n46), .Z(n56) );
	MUX2X1 MUX2X1_6 ( .S(n32), .A(n56), .B(n55), .Z(n57) );
	INV_Skipped INV_Skipped_5 ( .A(n36), .Z(n58) );
	INV_Skipped INV_Skipped_6 ( .A(n37), .Z(n59) );
	NAND2X1 NAND2X1_39 ( .A(n59), .B(n58), .Z(n60) );
	NAND2X1 NAND2X1_40 ( .A(n37), .B(n36), .Z(n61) );
	INV_C INV_C_2 ( .A(n61), .Z(n62) );
	MUX2X1 MUX2X1_7 ( .S(n35), .A(n60), .B(n62), .Z(n63) );
	NAND2X1 NAND2X1_41 ( .A(top^b~1), .B(top^a~3), .Z(n64) );
	INV_Skipped INV_Skipped_7 ( .A(n64), .Z(n65) );
	XOR2X1 XOR2X1_9 ( .A(n65), .B(n63), .Z(n66) );
	NAND2X1 NAND2X1_42 ( .A(top^b~2), .B(top^a~2), .Z(n67) );
	INV_B INV_B_2 ( .A(n67), .Z(n68) );
	XOR2X1 XOR2X1_10 ( .A(n68), .B(n66), .Z(n69) );
	NOR2X1 NOR2X1_4 ( .A(n37), .B(n36), .Z(n70) );
	MUX2X1 MUX2X1_8 ( .S(n35), .A(n70), .B(n61), .Z(n71) );
	XOR2X1 XOR2X1_11 ( .A(n65), .B(n71), .Z(n72) );
	XOR2X1 XOR2X1_12 ( .A(n68), .B(n72), .Z(n73) );
	MUX2X1 MUX2X1_9 ( .S(n57), .A(n73), .B(n69), .Z(n74) );
	NAND2X1 NAND2X1_43 ( .A(top^b~3), .B(top^a~1), .Z(n75) );
	INV_D INV_D_2 ( .A(n75), .Z(n76) );
	NAND2X1 NAND2X1_44 ( .A(n76), .B(n74), .Z(n77) );
	INV_Skipped INV_Skipped_8 ( .A(n74), .Z(n78) );
	NAND2X1 NAND2X1_45 ( .A(n75), .B(n78), .Z(n79) );
	NAND2X1 NAND2X1_46 ( .A(n79), .B(n77), .Z(n80) );
	XOR2X1 XOR2X1_13 ( .A(n76), .B(n74), .Z(n81) );
	MUX2X1 MUX2X1_10 ( .S(n54), .A(n80), .B(n81), .Z(top^out~4) );
	NOR2X1 NOR2X1_5 ( .A(n76), .B(n74), .Z(n83) );
	MUX2X1 MUX2X1_11 ( .S(n54), .A(n83), .B(n77), .Z(n84) );
	NOR2X1 NOR2X1_6 ( .A(n43), .B(n41), .Z(n85) );
	MUX2X1 MUX2X1_12 ( .S(n32), .A(n85), .B(n44), .Z(n86) );
	NOR2X1 NOR2X1_7 ( .A(n67), .B(n66), .Z(n87) );
	NAND2X1 NAND2X1_47 ( .A(n67), .B(n66), .Z(n88) );
	MUX2X1 MUX2X1_13 ( .S(n86), .A(n88), .B(n87), .Z(n89) );
	NAND2X1 NAND2X1_48 ( .A(n65), .B(n71), .Z(n90) );
	NAND2X1 NAND2X1_49 ( .A(top^b~2), .B(top^a~3), .Z(n91) );
	XOR2X1 XOR2X1_14 ( .A(n91), .B(n90), .Z(n92) );
	INV_Skipped INV_Skipped_9 ( .A(n92), .Z(n93) );
	INV_Skipped INV_Skipped_10 ( .A(n91), .Z(n94) );
	XOR2X1 XOR2X1_15 ( .A(n94), .B(n90), .Z(n95) );
	INV_B INV_B_3 ( .A(n95), .Z(n96) );
	MUX2X1 MUX2X1_14 ( .S(n89), .A(n96), .B(n93), .Z(n97) );
	NAND2X1 NAND2X1_50 ( .A(top^b~3), .B(top^a~2), .Z(n98) );
	INV_D INV_D_3 ( .A(n98), .Z(n99) );
	NAND2X1 NAND2X1_51 ( .A(n99), .B(n97), .Z(n100) );
	MUX2X1 MUX2X1_15 ( .S(n89), .A(n95), .B(n92), .Z(n101) );
	NAND2X1 NAND2X1_52 ( .A(n98), .B(n101), .Z(n102) );
	NAND2X1 NAND2X1_53 ( .A(n102), .B(n100), .Z(n103) );
	XOR2X1 XOR2X1_16 ( .A(n99), .B(n97), .Z(n104) );
	MUX2X1 MUX2X1_16 ( .S(n84), .A(n103), .B(n104), .Z(top^out~5) );
	NOR2X1 NOR2X1_8 ( .A(n99), .B(n97), .Z(n106) );
	MUX2X1 MUX2X1_17 ( .S(n84), .A(n106), .B(n100), .Z(n107) );
	NOR2X1 NOR2X1_9 ( .A(n64), .B(n63), .Z(n108) );
	NAND2X1 NAND2X1_54 ( .A(n94), .B(n108), .Z(n109) );
	NOR2X1 NOR2X1_10 ( .A(n94), .B(n108), .Z(n110) );
	MUX2X1 MUX2X1_18 ( .S(n89), .A(n109), .B(n110), .Z(n111) );
	NAND2X1 NAND2X1_55 ( .A(top^b~3), .B(top^a~3), .Z(n112) );
	INV_Skipped INV_Skipped_11 ( .A(n112), .Z(n113) );
	XOR2X1 XOR2X1_17 ( .A(n113), .B(n111), .Z(n114) );
	XOR2X1 XOR2X1_18 ( .A(n112), .B(n111), .Z(n115) );
	MUX2X1 MUX2X1_19 ( .S(n107), .A(n114), .B(n115), .Z(top^out~6) );
	NOR2X1 NOR2X1_11 ( .A(n112), .B(n111), .Z(n117) );
	NAND2X1 NAND2X1_56 ( .A(n112), .B(n111), .Z(n118) );
	MUX2X1 MUX2X1_20 ( .S(n107), .A(n118), .B(n117), .Z(top^out~7) );
endmodule
